{
  open Evt
  open String
  open Hashtbl

  let tab = 
    let t = Hashtbl.create 30 in
      begin
	add t "B" B;
	add t "EM" EM;
	add t "I" I;
	add t "PL" PL;
	add t "S" S;
	add t "TT" TT;
	add t "U" U;
	add t "0" (Sz 0);
	add t "1" (Sz 1);
	add t "2" (Sz 2);
	add t "3" (Sz 3);
	add t "4" (Sz 4);
	add t "5" (Sz 5);
	add t "6" (Sz 6);
	add t "7" (Sz 7);
	add t "8" (Sz 8);
	add t "9" (Sz 9);
	add t "r" (Col Red);
	add t "g" (Col Green);
	add t "b" (Col Blue);
	add t "c" (Col Cyan);
	add t "m" (Col Magenta);
	add t "y" (Col Yellow);
	add t "k" (Col Black);
	add t "w" (Col White);
      end;
      t    

  let build tag =
    if (mem tab tag) 
    then Some (Push (find tab tag))
    else raise BadEvent

}

let alpha = ['a'-'z''A'-'Z'] 
let num = ['0'-'9']
let printing = ['\033'-'\059' '\061' '\063'-'\126']
let whitespace = ['\n''\r''\t'' ']
let text = (printing | whitespace) +
let alphanum = (alpha | num) +


rule token = parse
    
    "</" alphanum '>'         { let str = Lexing.lexeme lexbuf in 
				  Some Pop }

  | '<' alphanum '>'          { let str = Lexing.lexeme lexbuf in 
				  build (sub str 1 ((length str) - 2)) }      

  | text                      { Some (Txt (Lexing.lexeme lexbuf)) }
  | eof                       { None }
